; -----------------------------------------------------------------------------
;    ~     RetroForth for Linux
;   . .    http://www.retroforth.org
;   /V\    
;  // \\
; /(   )\
;  ^'~'^
; -----------------------------------------------------------------------------

format ELF executable
entry start	; entry point of the executable
;--------------------------------------------------------------------
include "../../macros.fasm"

section executable readable writeable
start:
	mov eax, 07dh              ;sys mprotect (pinched from IsForth :-)
	mov ebx, 08048000h
	mov ecx, 00100000h
	mov edx, 7
	int 080h                   ;make the entire program space rwx

	call driver_init
	mov esi, sp0

main:   upsh startup            ;Load startup code (startup.f)
        upsh startup.1 - startup
	call eval	
	call interpret
;---------------------------------------------------------------------
include "../../forth.asm"
include "drivers.asm"

flast dd forth_link
mlast dd macro_link
dlast dd domain_link
last dd dlast
;---------------------------------------------------------------------
startup:
file "../../forth.f"
file "drivers.f"
startup.1:
;---------------------------------------------------------------------
tib  rb   200h  ; was 'resb' 
sp0  rb   300h
d0   rb 10000h
h0   rb 80000h
;---------------------------------------------------------------------
