; -----------------------------------------------------------------------------
;    ~     RetroForth for Linux
;   . .    http://www.retroforth.org
;   /V\    
;  // \\
; /(   )\
;  ^'~'^
; -----------------------------------------------------------------------------

%include "../../macros.nasm"

section .text
	global main
main:
	mov eax, 07dh              ;sys mprotect (pinched from IsForth :-)
	mov ebx, 08048000h
	mov ecx, 00100000h
	mov edx, 7
	int 080h                   ;make the entire program space rwx	

        mov esi, sp0
	
	call sdl_init
 	mov eax,[screen]
	mov eax,[eax+PIXELS_OFS]
 	mov [frame],eax

MAIN:   upsh startup            ;Load startup code (startup.f)
        upsh startup.1 - startup
        call eval
	call interpret
;---------------------------------------------------------------------
%include "../../common/forth.asm"
%include "../../common/forth.dict"
%include "drivers.asm"
;---------------------------------------------------------------------
section .data
startup: incbin "../../common/forth.f"
         incbin "drivers.f"
.1
END
